﻿using System.ComponentModel;

namespace TestProject;

/// <summary>
/// 직원
/// </summary>
public class Employee : INotifyPropertyChanged
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Event
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 속성 변경시 이벤트 - PropertyChanged

    /// <summary>
    /// 속성 변경시 이벤트
    /// </summary>
    public event PropertyChangedEventHandler PropertyChanged;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region Field

    /// <summary>
    /// ID
    /// </summary>
    private int id;

    /// <summary>
    /// 성명
    /// </summary>
    private string name;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region ID - ID

    /// <summary>
    /// ID
    /// </summary>
    public int ID
    {
        get
        {
            return this.id;
        }
        set
        {
            if(this.id == value)
            {
                return;
            }

            this.id = value;

            FirePropertyChangedEvent(nameof(ID));
        }
    }

    #endregion
    #region 성명 - Name

    /// <summary>
    /// 성명
    /// </summary>
    public string Name
    {
        get
        {
            return this.name;
        }
        set
        {
            if(this.name == value)
            {
                return;
            }

            this.name = value;

            FirePropertyChangedEvent(nameof(Name));
        }
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Protected

    #region 속성 변경시 이벤트 발생시키기 - FirePropertyChangedEvent(propertyName)

    /// <summary>
    /// 속성 변경시 이벤트 발생시키기
    /// </summary>
    /// <param name="propertyName">속성명</param>
    protected void FirePropertyChangedEvent(string propertyName)
    {
        PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
    }

    #endregion
}